package Nullstelle;

public class Nullstelle {
	
	public static void main(String args[]){
		int fktNmr = 1;
		double 		un = unInt(fktNmr),
					ob = obInt(fktNmr),
					x =  randomdouble(un, ob),
					xkurz = x,
					y = fktWertBerechnen(fktNmr,x);
		
		for(int i =0 ; i< 100000 ; i++){
			x =  Math.random()*(ob - un) + un;
			y =  fktWertBerechnen(fktNmr, x);
			if (y == 0){
				xkurz = x;
			}
			if (Math.abs(y) < Math.abs(fktWertBerechnen(fktNmr, xkurz))){
	    			xkurz = x;
	    	}
	  }
		
	  if(fktWertBerechnen(fktNmr, xkurz) != 0){
	  	if(fktWertBerechnen(fktNmr, Math.ceil(xkurz)) == 0) xkurz = Math.ceil(xkurz);
	  	if(fktWertBerechnen(fktNmr, Math.floor(xkurz)) == 0) xkurz = Math.floor(xkurz);
	  	
	  	if(fktWertBerechnen(fktNmr, Math.ceil(xkurz*10)/10) == 0) xkurz = Math.ceil(xkurz);
	  	if(fktWertBerechnen(fktNmr, Math.floor(xkurz*10)/10) == 0) xkurz = Math.floor(xkurz);
	  }
	  
	  xkurz = checkArea(fktNmr, xkurz);
	  
	  if(fktWertBerechnen(fktNmr, xkurz) == 0)
		 System.out.println(fktName(fktNmr) + ": x = " + xkurz + " y =" + fktWertBerechnen(fktNmr, xkurz));
	  else
	  	System.out.println("es gibt keine Nullstelle, der Nherungswert ist:.\n"
	  			+ fktName(fktNmr) 
	  			+ ": x = " + xkurz 
	  			+ " y = " + fktWertBerechnen(fktNmr, xkurz));
	}
	
	private static double checkArea(int fktNmr, double x) {
		if(x>=0){
			if(fktWertBerechnen(fktNmr, Math.ceil(x)) == 0) return Math.ceil(x);
			if(fktWertBerechnen(fktNmr, Math.floor(x)) == 0) return Math.floor(x);	  	
			if(fktWertBerechnen(fktNmr, Math.ceil(x*10)/10) == 0) return Math.ceil(x);
			if(fktWertBerechnen(fktNmr, Math.floor(x*10)/10) == 0) return Math.floor(x);
		}else{
			if(fktWertBerechnen(fktNmr, Math.ceil(-x)) == 0) return -Math.ceil(-x);
			if(fktWertBerechnen(fktNmr, Math.floor(-x)) == 0) return -Math.floor(-x);	  	
			if(fktWertBerechnen(fktNmr, Math.ceil(-x*10)/10) == 0) return -Math.ceil(-x);
			if(fktWertBerechnen(fktNmr, Math.floor(-x*10)/10) == 0) return -Math.floor(-x);
		}
	  	return x;
	}
	
	static String fktName(int fktNmr){
		switch(fktNmr){
		case 0: return "2*x+2";
		case 1: return "-x^2+2";
		case 2: return "x^2+2";
		}
		return "";
	}
	
	static double fktWertBerechnen(int fktNmr, double x){
		switch(fktNmr){
		case 0: return 2*x+2;
		case 1: return (-(Math.pow(x, 2)))+2;
		case 2: return (Math.pow(x, 2))+2;
		}
		return 1;
	}
	
	static double obInt(int fktNmr){
		switch(fktNmr){
		case 0: return 0.0;
		case 1: return -2.0;
		case 2: return 1.0;
		}
		return 1;
	}
	
	static double unInt(int fktNmr){
		switch(fktNmr){
		case 0: return -2.0;
		case 1: return 2.0;
		case 2: return -1.0;
		}
		return 1;
	}

	public static double randomdouble(double un, double ob){
		return ((Math.random() * (ob - un)) + un);
	}
}